/*********************************************
 * OPL 12.6.1.0 Model
 * Author: rpilling
 * Creation Date: 20/04/2015 at 11:10:05 PM
 *********************************************/

//declare sets
{string} G = ...;
int NbPeriods = ...;
range Periods = 1..NbPeriods;

// declare microgrid input variables 
float A[G] = ...;
float B[G]= ...;
float C[G]= ...;
float minpower[G] = ...;
float maxpower[G] = ...;
float demandM[Periods] = ...;
float demandU[Periods] = ...;
float PVout[Periods] = ...;


// declare microgrid decision variables
dvar float+ x[G][Periods];

//  objective function (capacity)
minimize
  sum(g in G, t in Periods)(A[g]*(x[g][t])^2 + B[g]*x[g][t] + C[g]);
    
// constraint equations        
subject to {

// global power balance constraint 
forall (t in Periods)
  ctDemand: sum(g in G)x[g][t] >= demandM[t] + demandU[t] - PVout[t];// balance equation
  
// DG power limit constraints
forall (g in G, t in Periods)
  ctDGLowerLimit: x[g][t] >= minpower[g];

forall (g in G, t in Periods)
  ctDGUpperLimit: x[g][t] <= maxpower[g];
}