/*********************************************
 * OPL 12.6.1.0 Model
 * Author: rpilling
 * Creation Date: 20/04/2015 at 11:10:05 PM
 *********************************************/

//declare sets
{string} G = ...;
int NbPeriods = ...;
range Periods = 1..NbPeriods;

// declare microgrid input variables 
float A[G] = ...;
float B[G]= ...;
float C[G]= ...;
float demand[Periods] = ...;

// declare microgrid decision variables
dvar float+ xU[G][Periods];

//  objective function (capacity)
minimize
  sum(k in G, t in Periods)(A[k]*(xU[k][t])^2 - B[k]*xU[k][t] + C[k]);
  
// constraint equations        
subject to {

// global power balance constraint 
forall (t in Periods)
  ctDemand: sum(k in G)xU[k][t] == demand[t];
}