/*********************************************
 * OPL 12.6.1.0 Model
 * Author: rpilling
 * Creation Date: 20/04/2015 at 11:10:05 PM
 *********************************************/

//declare sets
{string} DG = ...;
int NbPeriods = ...;
range Periods = 1..NbPeriods;

// declare microgrid input variables 
float mcM[DG] = ...;
float ciM[DG]= ...;
float minpowerM[DG] = ...;
float demandM[Periods] = ...;
float PVout[Periods] = ...;

// declare microgrid decision variables
dvar float+ xM[DG][Periods];
dvar float+ maxpowerM[DG];

//  objective function (capacity)
minimize
  sum(k in DG, t in Periods)(mcM[k]*xM[k][t]);

// constraint equations        
subject to {

// global power balance constraint 
forall (t in Periods)
  ctDemand: sum(k in DG)xM[k][t] >= demandM[t] - PVout[t];// balance equation

// DG power limit constraints
forall (k in DG, t in Periods)
  ctDGLowerLimit: xM[k][t] >= minpowerM[k];

forall (k in DG, t in Periods)
  ctDGUpperLimit: xM[k][t] <= maxpowerM[k];
}